<?php if(!defined('PmWiki'))exit;
/*

Integration of responsiveslides.js (http://responsiveslides.com/) for PmWiki
Ref : http://www.pmwiki.org/wiki/Cookbook/ResponsiveSlides

Written by (c) 2016 Antony Templier www.pmwiki.org/wiki/Profiles/AntonyTemplier

  This software is under WTFPL License:
  ------------------------------------------------------------------------------
              DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
                      Version 2, December 2004

   Copyright (C) 2004 Sam Hocevar <sam@hocevar.net>

   Everyone is permitted to copy and distribute verbatim or modified
   copies of this license document, and changing it is allowed as long
   as the name is changed.

              DO WHAT THE FUCK YOU WANT TO PUBLIC LICENSE
     TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION

    0. You just DO WHAT THE FUCK YOU WANT TO.
  ------------------------------------------------------------------------------


  This script is heavily based on the galleria script
  (http://www.pmwiki.org/wiki/Cookbook/Galleria) written by David Gilbert
  under a Creative Commons Attribution-Share Alike 4.0 International License.

  This script use ResponsiveSlides.js (https://github.com/viljamis/ResponsiveSlides.js)
  published under the MIT Licence.



Installation:
=============

cookbook/responsiveslides.php
pub/responsiveslides/responsiveslides.css
                     responsiveslides.min.js
                     themes.gif

Configuration:
==============

include_once("$FarmD/cookbook/responsiveslides.php");

Usage in pmwiki:
================

>>gallery<<
* Attach:elephant1.jpg"One elephant"
  %caption%Here you can write a legend
* Attach:elephant2.jpg"Another elephant"
  %caption%Another title
* Attach:elephant3.jpg"Elephant"
  %caption%Title 3
* Attach:elephant_bali.jpg"Elephant in Bali"
  %caption%Title 4
>><<

(:responsiveslides:)

*/

$RecipeInfo['ResponsiveSlides']['Version'] = '2016-07-05';


SDVA($HTMLHeaderFmt, array(
    'rslides-jquery' => "<script src='http://ajax.googleapis.com/ajax/libs/jquery/1.8.3/jquery.min.js'></script>\n",
    'rslides-js' => "<script src='".$PubDirUrl."/responsiveslides/responsiveslides.min.js'></script>\n",
    'rslides-css' => "<link rel='stylesheet' href='".$PubDirUrl."/responsiveslides/responsiveslides.css' type='text/css' media='screen'/>\n"
));

SDV($rslides_safe_mode, true);
SDVA($rslides_options,array(
    'list' => '.gallery', # If you change this, you need to check your css.
    'pager' => true,
    'nav' => true,

    // List of options with their default value
    /*
    'list' => '.gallery',       // String: Css root element's name for list of images
    'auto' => true,             // Boolean: Animate automatically, true or false
    'speed' => 500,             // Integer: Speed of the transition, in milliseconds
    'timeout' => 4000,          // Integer: Time between slide transitions, in milliseconds
    'pager' => false,           // Boolean: Show pager, true or false
    'nav' => false,             // Boolean: Show navigation, true or false
    'random' => false,          // Boolean: Randomize the order of the slides, true or false
    'pause' => false,           // Boolean: Pause on hover, true or false
    'pauseControls' => true,    // Boolean: Pause when hovering controls, true or false
    'prevText' => 'Previous',   // String: Text for the "previous" button
    'nextText' => 'Next',       // String: Text for the "next" button
    'maxwidth' => '',           // Integer: Max-width of the slideshow, in pixels
    'navContainer' => '',       // Selector: Where auto generated controls should be appended to, default is after the <ul>
    'manualControls' => '',     // Selector: Declare custom pager navigation
    'namespace' => 'rslides',   // String: change the default namespace used
    'before' => '$.noop',       // Function: Before callback
    'after' => '$.noop'         // Function: After callback
    */
    ));


SDVA($rslides_unsafe_options, array('before', 'after'));

Markup_e('responsiveslides', 'inline', "/\\(:responsiveslides\\s*(.*?):\\)/s", "Keep(responsiveslides(\$m[1]))");


function responsiveslides ($args=false) {
global $rslides_options, $rslides_unsafe_options, $rslides_safe_mode;

    $args = ParseArgs($args);
    unset($args['#']);

    if ($rslides_safe_mode)  #remove unsafe options from markup args -- only allow from config.php
        foreach ($rslides_unsafe_options as $v)
            unset($args[$v]);

    $o = array_merge($rslides_options, $args);

    return '
<script type="text/javascript">
$(document).ready(function(){
    $("'.$o['list'].' ul").responsiveSlides(' .rslides_json_encode($o, false, $rslides_unsafe_options). ');
});
</script>';
}

#json_encode only in PHP5.2+. Rather than overriding json_encode, and supporting two versions. ref http://www.mike-griffiths.co.uk/php-json_encode-alternative/
#$strict will wrap the key in quotes.
#keys in $np array if found in $a will not have VALUES wrapped in quotes. Allows javascript functions to be option values.
function rslides_json_encode($a=false, $strict=true, $np=false){
    if (is_null($a)) return 'null';
    if ($a === false) return 'false';
    if ($a === true) return 'true';
    if (is_scalar($a)){
        if (is_float($a) || is_numeric($a))  return floatval(str_replace(",", ".", strval($a)));  #Always use "." for floats.
        if (is_string($a)) {
            static $jsonReplaces = array(array("\\", "/", "\n", "\t", "\r", "\b", "\f", '"'), array('\\\\', '\\/', '\\n', '\\t', '\\r', '\\b', '\\f', '\"'));
            return '"' . str_replace($jsonReplaces[0], $jsonReplaces[1], $a) . '"';
        }else  return $a;
    }
    $isList = true;
    for ($i = 0, reset($a); $i < count($a); $i++, next($a))
        if (key($a) !== $i){ $isList = false; break; }
    $result = array();
    if ($isList){
        foreach ($a as $v)  $result[] = rslides_json_encode($v, $strict, $np);
        return '[ ' . join(', ', $result) . ' ]';
    }else{
        foreach ($a as $k => $v) $result[] = ($strict ?rslides_json_encode($k, $strict, $np) :$k) .': ' .(in_array($k, $np) ?$v :rslides_json_encode($v, $strict, $np));
        return '{ ' . join(', ', $result) . ' }';
    }
}
